/*
******************************************************
    Nom du projet: TP2      Etudiante: Cherlie Rivage
******************************************************

    Date de la dernire rvision: 28 novembre 2023

    Enonc:Programme en langage C pour effectuer la division de nombres entiers positifs de 16 bits
    par restauration des restes partiels.
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

//Fonction permettant la division binaire par restauration des restes partiels


/* Description:

INPUT: passage par valeur de type unsigned int
	-parametre1 a: Dividende
	-parametre2 b: Diviseur

 *OUTPUT: unsigned int

*/

unsigned int division(unsigned int a, unsigned int b)           // a : dividende    b : diviseur
{
    int i;
    b = b << 16;                                               // Decalage de b de 16 bits  gauche
    for (i = 0; i < 16; i++)
    {
        a = a << 1;                                          // Decalage de a de 1 bit par la gauche

        if (a >= b)                                         // Dividende >= Diviseur
        {
            a = a - b;
            a = a + 1;
        }
    }

    return a;
}

// Mthode permettant la validation et la vrification des nombres saisis par l'utilisateur

unsigned int test_entier()
{
    unsigned int x;                                   //Un entier quelconque
    char nbr1[15];
    bool test = false;

    while (test == false)
    {
        printf("Veuillez saisir un entier : ");
        scanf("%14s", nbr1);
        if (sscanf(nbr1, "%u", &x) == 1)
        {
            test = true;
        }
        else
        {
            printf("Ceci n'est pas un entier, veuillez saisir un entier.\n");
            test = false;
        }
    }

    return x;
}

// La fonction main

int main()
{
//Initialisation des variables

    unsigned int i, d, a, b, N;
    unsigned short c = 0;

//Ouverture du fichier en mode criture

    FILE *rep;
    rep = fopen("reponse.txt", "w");

    printf("Veuillez saisir le nombre de divisions a effectuer : ");
    N = test_entier();

    while (N < 1 || N > 65535)
    {
        printf("Le nombre saisi doit etre compris dans l'intervalle [1,65535].\n");
        N = test_entier();
    }

    printf("Veuillez saisir la ou les divisions a effectuer :\n");

    for (i = 1; i <= N; i++)
    {
        printf("Entrez le dividende de la %ieme division : ", i);
        a = test_entier();

        while (a <= 0 || a > 65535)
        {
            printf("Le dividende doit etre dans l'intervalle [0,65535].\n");
            a = test_entier();
        }

        printf("Entrez le diviseur de la %ieme division : ", i);
        b = test_entier();

        while (b <= 1 || b > 65535)
        {
            printf("Le diviseur doit etre dans l'intervalle [1,65535].\n");
            b = test_entier();
        }

        d = division(a, b);                 /* La division de a par b */
        c = (unsigned short)d;              /* Les 16 premiers bits*/
        d = (d >> 16);                      /* Les 16 derniers bits*/

        fprintf(rep, "%i/%i = %i et le reste est: %i\n", a, b, c, d);
    }

    fclose(rep);                // Fermeture du fichier

    return 0;
}
