#include <stdio.h>

// Desactiver l'avertissement 4996 pour la fonction fopen (utilisation securisee)
#pragma warning(disable : 4996)

/// <summary>
///                 
/// Main.c 
/// 
///     
/// Simon Hubert HUBS28088905 / Vincent Lacroix LACV78060404
/// Groupe 00
/// 
/// Fichier source du projet. Point d'entre du programme.
/// </summary>


 /*
                 2023-11-12; SH/VL --> Creation de la fonction.
                  @FNC_NAME: division();
                  @DESCRIPTION:    Fonction de division binaire par restauration des restes partiels.
                  @PARAM_INPUT:     
                    // Parametre 1: dividende
                    // Parametre 2: diviseur
                    // Parametre 3: reste
                  @PARAM_OUTPUT:   u int
 */
unsigned int division(unsigned int dividende, unsigned int diviseur, unsigned int* reste) {
    // Initialisation des variables
    unsigned int quotient = 0;
    *reste = 0;

    // Parcours des bits du dividende
    for (int i = 15; i >= 0; i--) {
        // Dcalage du reste prcdent et ajout du bit actuel du dividende
        // Oprateur << (dcalage  gauche) :
        *reste = (*reste << 1) | ((dividende >> i) & 1);

        // Soustraction du diviseur si le reste est plus grand ou gal au diviseur
        if (*reste >= diviseur) {
            *reste -= diviseur;
            quotient = (quotient << 1) | 1; // Ajout du bit au quotient
        }
        else {
            quotient <<= 1; // Dcalage  gauche du quotient
        }
    }

    return quotient;
}

int main() {
    // Ouverture du fichier en criture
    FILE* fichier = fopen("resultats.txt", "w");

    // Vrifications lors de l'ouverture du fichier
    if (fichier == NULL) {
        fprintf(stderr, "Erreur lors de l'ouverture du fichier.\n");
        return 1;
    }

    // Nombre de divisions  effectuer
    int nombreDivisions;
    printf("Entrez le nombre de divisions a effectuer : ");
    scanf_s("%d", &nombreDivisions);

    // Effectuer chaque division
    for (int i = 1; i <= nombreDivisions; i++) {
        unsigned int dividende, diviseur, reste;
        int nbValide = -1;

        while (nbValide != 0)
        {

            // Saisie des valeurs du dividende et du diviseur
            printf("Division %d : Entrez le dividende (0-65535) et le diviseur (1-65535) : ", i);
            scanf_s("%u %u", &dividende, &diviseur);

            // Vrification des valeurs dans l'intervalle
            if (dividende < 0 || dividende > 65535 || diviseur < 1 || diviseur > 65535) {
                fprintf(stderr, "Erreur : Les valeurs doivent etre dans les intervalles specifies.\n");
                
            }

            // Vrification du diviseur non nul
            else if (diviseur == 0) {
                fprintf(stderr, "Erreur : Le diviseur ne peut pas etre zero.\n");
           
            }

            else {
                nbValide++;
            }
            
        }
        // Calcul de la division
        unsigned int resultat = division(dividende, diviseur, &reste);

        // Affichage des rsultats  l'cran
        printf("Division %d : %u / %u = %u reste %u\n", i, dividende, diviseur, resultat, reste);

        // criture des rsultats dans le fichier
        fprintf(fichier, "Division %d : %u / %u = %u reste %u\n", i, dividende, diviseur, resultat, reste);

    }

    // Fermeture du fichier
    fclose(fichier);

    return 0;
}
