// TP2 - Architecture des ordinateurs.c : This file contains the 'main' function./
/* GROUP: 00 (mardi)
 * AUTHORS:
 *   Benjamin Gauthier        GAUB65090309
 *   Louis-Philip Marcoux     MARL66030200
 */

#include <stdio.h>

 // TITLE: scanShort
 /* DESCRIPTION: Function that replaces the scanf_s function in this code for short variables scanning.
  * Scans for short integers and ask the user for an input as long as the input is incorrect.
  */
  // INPUT : None
  // OUPTUT: value ~ short integer
short int scanUnsignedShort();

// TITLE Division
/* DESCRIPTION: Divides two short integers using an implementation of Euclidean division,
 * that operates with shift operators.
 */
 // INPUT : dividend ~ unsigned int (but in reality, you would input a short integer)
 //         divider  ~ unsigned int (but in reality, you would input a short integer)
 // OUPTUT: dividend ~ contains in the remainder in the last 16 bits, and the quotient in the first 16 bits.
unsigned int Division(unsigned int dividend, unsigned int divider);

 // --- MAIN ---
 /* DESCRIPTION: We ask the user the number of divisions to perform, and for each, what is the dividend
  * and divider. The results are written to a file in the same directory.
  * GROUP: 00 (mardi)
  * AUTHORS:
  *   Benjamin Gauthier        GAUB65090309
  *   Louis-Philip Marcoux     MARL66030200
  */
int main()
{
    unsigned short int dividend, divider, divisionMax;
    unsigned int result;
    int divisionNum;

    // Opening file
    _Post_ _Notnull_ FILE* file;
    fopen_s(&file, "results.txt", "w");

    // Asking user number of divisions to perform
    printf("How many divisions would you like to do? : ");
    divisionMax = scanUnsignedShort();

    for (divisionNum = 1; divisionNum <= divisionMax; divisionNum++)
    {
        // Fetching dividend and divider
        printf("Division #%d\nInsert the dividend : ", divisionNum);
        dividend = scanUnsignedShort();
        printf("Insert the divider (greater than 0) : ");
        divider = scanUnsignedShort();

        // Making sure divider is not 0
        while (divider == 0 || divider > dividend)
        {
            if (divider == 0) printf("Input is equal to 0, which makes the division infinite. Try again : ");
            else printf("Input is greater than dividend. Try again : ");
            divider = scanUnsignedShort();
        }
        printf("\n");

        // Calculating the result of the division
        result = Division(dividend, divider);

        // Writing result to file
        fprintf(file, "Division %d : %u/%u = %u remains %u\n", divisionNum, dividend, divider, result & 0xFFFF, result >> 16);
    }
    // Closing file
    fclose(file);

    return 0;
}

short int scanUnsignedShort()
{
    int validInput = 0;
    int successfulScan = 0;
    float scannedValue = 0;
    unsigned short int value = 0;

    // validInput is the exit condition.
    while (validInput != 1)
    {
        // successfulScan returns 1 if the input is an acceptable float
        successfulScan = scanf_s("%f", &scannedValue);
        value = (unsigned short int)scannedValue;

        /* IF rounded values is the same as inputted value
         OR the initial scan was not a float (a string) */
        if (scannedValue != value || successfulScan == 0) printf("Input is not a valid unsigned short. Try again : ");
        else validInput = 1;
        // Clear buffer if scan was a string
        while (getchar() != '\n');
    }

    return value;
}

unsigned int Division(unsigned int dividend, unsigned int divider)
{
    int diff;

    // divider is moved to the last 16 bits.
    divider <<= 16;
    
    /* We then shift the dividend left each iteration, as you would do in
     * an Euclidean division as you iterate through each substraction.
    */
    for (int i = 1; i <= 16; i++)
    {
        // Shift left, then substract.
        diff = (dividend <<= 1) - divider;

        /* If the difference is positive, it means the divider fits in the dividend, thus the divider
         * CAN divide the dividend and we can store this result in the first 16 bits with +1.
         * This +1 is then shifted left in a next iteration to leave room for the +1, if any.
        */
        if (diff >= 0) dividend = diff + 1;
    };
    /* The first 16 bits contains all the + 1 we did or, in other words, how many time the divider fits
     * in the dividend. This is the quotient. The remainder is in the last 16 bits since we ended the loop
     * at the 16th iteration, thus leaving the last state of the dividend untouched.
    */
    return dividend;
}