
//*******************************************************************************************************************************
//
// Auteurs: Ninaud Larry Djomo Nzoubou/Ousmane Souleymane/Sarrah Rida Sbay/Ndjotcha Jobine
// Codes permanents : DJON84310000/SOUO90300400/RIDS91530400/NDJJ70370100
// GROUPE 00 (Mardi)
//
//*******************************************************************************************************************************


#include <stdio.h>

/*Cette partie comprend la fonction qui va effectuer la division en utilisant la méthode de division binaire par :

    - Addittion
    - Soustraction 
    - Décalage 

*/

//Initialisation des variables pour la division, entier positifs non signés int. 
unsigned int division(unsigned int a, unsigned int b, unsigned int *c) {
    unsigned int d = 0;
    *c = 0;

    //Cette boucle permet de parcourir les bits du a pour effectuer l'opération
    for (int i = 15; i >= 0; i--) {
        *c = (*c << 1) | (( a >> i) & 1); 
         //Cette commande décale le reste de la division précédente et l'ajoute au dividende

    //Utilisation de la soustraction pour actualiser le quotient de la division
        if (*c >= b) {
            *c = *c - b;
            d = (d << 1) | 1;
        } else {
            d = d << 1;
        }
    }

    return d;
}






int main() {

    //La commande FILE permet d'initialiser le pointeur qui renverra au fichier texte des résultats
    FILE *FichierTexte; 
    int Divisions;

    //Cette commande permet d'ouvrir le fichier final résultats.txt en écriture "w" pour initier le stockage des résultats des calculs
    FichierTexte = fopen("Resultats.txt", "w");

    //Conditions qui s'affiche en cas d'erreur lors de l'ouverture du fichier texte
    if (FichierTexte == NULL) {
        printf("Désolé le fichier comporte une erreur.");
        return 1;
    }

    //Commandes pour initialiser le nombre de divisions qui sera effectué par l'utilisateur
    printf("Combien de division voulez vous effectuer ? :");
    scanf("%d", &Divisions);

    //La boucle présente initialise les variables en entier positif pour la division et effectue les calculs
    for (int i = 1; i <= Divisions; i++) {
        unsigned int a, b, c;
        int d;

    //Fonction qui s'affiche à la console demandant à l'utilisateur d'entrer le a et le b pour chaque opération.
    printf("Division %d: Entrez le dividende et le diviseur de la division :", i);
    scanf("%u %u", &a, &b);
    

        //La condition vérifie pour voir si le diviseur est différent de 0, si oui, le fichier texte se ferme et le programme interrompt le calcul
        if (b == 0) {
            printf("Désolé, le programme ne peux effectuer de division par 0.");
            fclose(FichierTexte);
            return 1;
        }

        //Utilisation de la fonction de division binaire
        d = division(a, b, &c);

        //Stockage des résultats dans le fichier résultats.txt
        fprintf(FichierTexte, "Division %d: %u / %u = %d Reste %u\n", i, a, b, d, c);
    }


    fclose(FichierTexte);

    printf("Veuillez vous reférer aux fichier résultats.txt pour avoir vos réponses, Merci :) !");

    return 0;
}

