//Authors:
// Mohamed Essedik Chebli 
//NDEYE GUILADO SAO 
// Raslen Abdallah 

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

// la fonction de division
unsigned int division(unsigned int a, unsigned int b);

// la fonction de contrôle de saisie
unsigned int controleSaisie();

int main() {
    unsigned int i, a, b, d, N;
    unsigned short c;
    FILE *rep;

    // Ouverture du fichier en mode écriture
    rep = fopen("reponse.txt", "w");

    printf(" Veuillez entrez le nombre de division à effectuer : ");

    // Contrôle de saisie pour le nombre de divisions
    N = controleSaisie();

    while (N < 1 || N > 65535) {
        printf("Veuillez entrer un chiffre compris entre 1 et 65535.\n");
        N = controleSaisie();
    }

    for (i = 1; i <= N; i++) {
        printf("Division %d : Entrez le dividende (entre 0 et 65535) : ", i);

        // Contrôle de saisie pour le dividende
        a = controleSaisie();

        while (a < 0 || a > 65535) {
            printf("Intervalle du dividende : de 0 à 65535.\n");
            a = controleSaisie();
        }

        printf("Division %d : Entrez le diviseur (entre 1 et 65535) : ", i);

        // Contrôle de saisie pour le diviseur
        b = controleSaisie();

        while (b <= 0 || b > 65535) {
            printf("Intervalle du diviseur : de 1 à 65535.\n");
            b = controleSaisie();
        }

        // Appel de la fonction de division
        d = division(a, b);

        // Extraction des 16 premiers bits ( le quotient)
        c = (unsigned short)d;

        // Extraction des 16 derniers bits ( le reste)
        d = (d >> 16);

        // Écriture dans le fichier et affichage à l'écran
        fprintf(rep, "Division %i: %i / %i = %d reste %i\n", i, a, b, c, d);
    }

    //  la fermeture du fichier
    fclose(rep);

    return 0;
}

//  la Fonction de division de deux nombres entiers positifs de 16 bits
unsigned int division(unsigned int a, unsigned int b) {
    int i;
    b = b << 16; //  Nous avons un décalage de 16 bits à gauche

    for (i = 0; i < 16; i++) {
        a = a << 1; // Nous avons un  décalage de 1 bit à gauche

        //  La condition pour effectuer la soustraction
        if (a >= b) {
            a = a - b;
            a = a + 1;
        }
    }

    return a;
}

// Fonction de contrôle de saisie
unsigned int controleSaisie() {
    unsigned int p;
    char c;
    bool ctrl = false;

    //  La boucle tant que la saisie n'est pas valide
    while (ctrl == false) {
        scanf("%s", &c);

        // Une Vérification de la conversion en entier
        if (sscanf(&c, "%u", &p) == 1) {
            ctrl = true;
        } else {
            printf("Entrez un entier, s'il vous plaît.\n");
            ctrl = false;
        }
    }

    return p;
}
