/*Division de nombres binaires entiers positifs de 16 bits
Le présent algorithme permet de faire des divisions de nombres entiers positifs de 16 bits choisis par 
l'utilisateur et qui sont stockés dans un document <<.txt>> externe. Le document est créé lui-même s'il
n'existe pas. L'algorithme présenté corrige l'utilisateur si les nombres choisis n'entrent pas dans 16
bits ou si le diviseur est 0.

Groupe 00
Sophie Garneau-Lévesque (GARS70600107)
Raphaël Marier (MARR66030204)
Keleiali'i Urima (URIK76510105)


Input:  a = unsigned int, stocke les valeurs des différents dividendes.
        b = unsigned int, stocke les valeurs des différents diviseurs.
Output: a = unsigned int, imprime le reste et le quotient.
*/

#include <iostream> 
#include <conio.h>
#include <cstdio>

unsigned int division(unsigned int a, unsigned int b);

int main(){
    unsigned int i, a, b, d, N;
    unsigned short c;
    FILE *rep;
    rep = fopen("reponse.txt","w");                                 /*Ouverture du fichier*/

    printf("Entrer le nombre de division à effecturer\n");
    scanf("%i", &N);                                                /*Entrer le nombre de division à effectuer*/

    printf("Entrer la ou les divisions à effectuer\n");
    printf("de la façon suivante : a/b\n");
    
    for(i=1;i<N+1;i++)
    {
        printf("Division %i \n", i);                                           /*Rappel du numéro de la division*/
        scanf("%i / %i", &a, &b);                                               /*Entrer a/b*/
        if(a > 65535 || a < 0)
        {
            while(a > 65535 || a < 0)                                           /*Boucle qui permet de corriger l'utilisateur si le dividende est de plus de 16 bits*/
            {
                printf("Le dividende doit être entre 0 et 65535. Veuillez entrer un nouveau dividende (reprendre seulement le dividende) : \n");
                scanf("%i", &a);
            }
        }   

        if(b > 65535 || b < 1)
        {
            while(b > 65535 || b < 1)                                           /*Boucle qui permet de corriger l'utilisateur si le diviseur est de plus de 16 bits ou est 0*/
            {
            printf("Le diviseur doit être entre 1 et 65535. Veuillez entrer un nouveau diviseur (reprendre seulement le diviseur) : \n");
            scanf("%i", &b);
            };
        };
        
        d = division(a,b);                                                      /*La division de a par b*/
        c = d;                                                                  /*Les 16 premiers bits*/
        d = (d >> 16);                                                          /*Les 16 derniers bits*/
        fprintf(rep, "Division %i : %i/%i = %d reste %i\n", i, a ,b ,c ,d);     /*Implémenter les valeur obtenues dans le fichier .txt*/

    }
    fclose(rep);                    /*Fermeture du fichier*/
    return a;
}

unsigned int division(unsigned int a, unsigned int b)
{   int i;
    b = b << 16;                                        /*Décalage des bits stockés en b vers la gauche (16 fois)*/

    for(i=0;i<16;i++)
    {                                                   /*Boucle qui permet de parcourir chaque bit en a et de soustraire b lorsqu'applicable*/
        a = a << 1;
        if(a>=b)
        {
            a = a-b;
            a = a + 1;
        }
    }

    return a;           /*Quotient : 16 BLMS reste 16 BLPS*/
}
 
