//(00 MARDI) GAGE82070402 Elliott Gagnon,VERE86040404 Esteban Vernier, COUA93080208 Antoine Coutu
#include <stdio.h>
#include <errno.h>

// Fonction pour effectuer la division
// Input : 
//   - dividend (unsigned int) : le dividende (nombre  diviser)
//   - divisor (unsigned int) : le diviseur (nombre par lequel diviser)
//   - remainder (unsigned int*) : pointeur vers la variable qui stockera le reste de la division
// Output : 
//   - unsigned int : le quotient de la division
// Description : Effectue la division binaire par restauration des restes partiels en utilisant les oprations d'addition, de soustraction et de dcalage.

unsigned int division(unsigned int dividend, unsigned int divisor, unsigned int* remainder) {
    unsigned int quotient = 0;
    *remainder = 0;

    // Parcours des bits du dividende
    for (int i = 15; i >= 0; i--) {
        *remainder = (*remainder << 1) | ((dividend >> i) & 1);
        quotient <<= 1;

        if (*remainder >= divisor) {
            *remainder -= divisor;
            quotient |= 1;
        }
    }

    return quotient;
}

int main() {
    int numDivisions;

    // Demander  l'utilisateur le nombre de divisions  effectuer
    printf("Entrez le nombre de divisions  effectuer : ");
    scanf_s("%d", &numDivisions);

    // Ouvrir le fichier en criture
    FILE* fp;
    errno_t err = fopen_s(&fp, "resultats.txt", "w");

    if (err != 0) {
        printf("Erreur lors de l'ouverture du fichier.\n");
        return 1;
    }

    // Effectuer les divisions
    for (int i = 1; i <= numDivisions; i++) {
        unsigned int dividend, divisor, remainder;

        // Demander  l'utilisateur les valeurs du dividende et du diviseur
        printf("Division %d: Entrez le dividende (entre 0 et 65535) : ", i);
        scanf_s("%u", &dividend);

        printf("Division %d: Entrez le diviseur (entre 1 et 65535) : ", i);
        scanf_s("%u", &divisor);

        // Vrifier la validit des entres
        if (dividend > 65535 || divisor == 0 || divisor > 65535) {
            printf("Entres non valides. Veuillez ressayer.\n");
            i--;
            continue;
        }

        // Appeler la fonction de division
        unsigned int quotient = division(dividend, divisor, &remainder);

        // crire les rsultats dans le fichier qui est situ dans le mme fichier que le fichier source
        fprintf(fp, "Division %d: %u / %u = %u reste %u\n", i, dividend, divisor, quotient, remainder);
    }

    // Fermer le fichier
    fclose(fp);

    printf("Les rsultats ont t enregistrs dans le fichier 'resultats.txt'.\n");

    return 0;
}
