#include <stdio.h>
//Prénom : GUO , NOM: YIMIN , CODE:GUOY63260000 ,Courriel : YIMIN.GUO@uqtr.CA//
typedef struct {
    unsigned int quotient;
    unsigned int remainder;
} DivisionResult;

DivisionResult binaryDivision(unsigned int dividend, unsigned int divisor) {
    DivisionResult result = {0, 0};

    if (divisor == 0) {
        printf("Le diviseur ne peut pas être 0.\n");
        return result;
    }

    unsigned int remainder = 0;
    /*unsigned int remainder = 0 ;Cette ligne de code initialise une variable entière non signée remainder, qui sera utilisée pour stocker les valeurs intermédiaires du reste lors de la division.*/
    for (int i = 15; i >= 0; i--) {
        remainder = (remainder << 1) | ((dividend >> i) & 1);
        /*Il s'agit d'une boucle inversée de 15 à 0. Comme il s'agit d'entiers de 16 bits, cette boucle traitera le diviseur bit par bit (diviser). i indique le bit en cours de traitement.*/
        if (remainder >= divisor) {
            remainder -= divisor;
            result.quotient |= (1 << i);
        }
    }

    result.remainder = remainder;
    return result;
}

int main() {
    int n;
    printf("Veuillez indiquer le nombre de divisions à effectuer： ");
    scanf("%d", &n);

    FILE *file = fopen("results.txt", "w");
    if (file == NULL) {
        printf("Erreur d'ouverture de fichier\n");
        return 1;
    }

    for (int i = 0; i < n; i++) {
        unsigned int dividend, divisor;
        printf("division %d:Entrez dividende et diviseur: : ", i + 1);
        scanf("%u %u", &dividend, &divisor);

        DivisionResult res = binaryDivision(dividend, divisor);
        fprintf(file, "division %d: %u / %u = %u reste %u\n", i + 1, dividend, divisor, res.quotient, res.remainder);
    }
    /*Cette ligne de code écrit le résultat de la division dans un fichier ouvert. Elle affiche le numéro de l'opération de division, le diviseur, le quotient calculé et le reste.*/

    fclose(file);
    return 0;
}
