//Autheur : Zombre fabien (ZOMF80360400), Charles Gansonre (GANC85360300), Zidouemba Donald (ZIDD71300200), Ouedraogo Darius Ulrich (OUEP69330300)
//Description : Ce travail permet de faire l'apprentissage du fonctionnement de la division de nombres binaires entiers positifs de 16 bits
#include <stdio.h>
#include <stdlib.h>

// Fonction de division binaire
// Retourne un entier 32 bits avec la partie haute tant le reste et la partie basse
unsigned int division(unsigned int dividende, unsigned int diviseur) {
    unsigned int quotient = 0, reste = 0;

    for (int i = 15; i >= 0; i--) {
        reste = (reste << 1) | ((dividende >> i) & 1);
        if (reste >= diviseur) {
            reste -= diviseur;
            quotient |= (1 << i);
        }
    }

    return (reste << 16) | quotient;
}

int main() {
    int nombre_divisions;
    printf("Entrez le nombre de divisions que vous voulez effectuer : ");
    scanf("%d", &nombre_divisions);

    FILE *fichier_resultats = fopen("resultats.txt", "w");
    if (fichier_resultats == NULL) {
        printf("Erreur lors de l'ouverture du fichier de rsultats.\n");
        return 1;
    }

    for (int i = 0; i < nombre_divisions; i++) {
        unsigned int dividende, diviseur;
        printf("Entrez le dividende (entre 0 et 65535) pour la division %d : ", i + 1);
        scanf("%u", &dividende);

        printf("Entrez le diviseur (entre 1 et 65535) pour la division %d : ", i + 1);
        scanf("%u", &diviseur);

        unsigned int resultat = division(dividende, diviseur);

        // Affichage du rsultat et criture dans le fichier
        printf("Division %d: %u / %u = %u reste %u\n", i + 1, dividende, diviseur, resultat & 0xFFFF, resultat >> 16);
        fprintf(fichier_resultats, "Division %d: %u / %u = %u reste %u\n", i + 1, dividende, diviseur, resultat & 0xFFFF, resultat >> 16);
    }

    fclose(fichier_resultats);

    return 0;
}
