#include <stdio.h>

// Fonction de division avec l'utilisation de la méthode de restauration des restes partiels

unsigned int division(unsigned int dividende, unsigned int diviseur, unsigned int *reste) {
    unsigned int quotient = 0;
    *reste = 0;

    // Boucle sur chaque bit du dividende
    for (int i = 15; i >= 0; i--) {
        *reste = (*reste << 1) | ((dividende >> i) & 1);

        // Vérifie si le reste est plus grand ou égal au diviseur
        if (*reste >= diviseur) {
            *reste -= diviseur;
            quotient = (quotient << 1) | 1;  // Ajoute 1 au quotient
        } else {
            quotient = quotient << 1;  // Décale vers la gauche dans le quotient
        }
    }

    return quotient;
}

// Mohammed Saad KHELLA KHEM63260500 , Rayan KOUKI KOUR89350300 , Louay BEN ROMDHANE BENL73370300
int main() {
    int nombreDivisions;


    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%d", &nombreDivisions);

    // Ouvre un fichier texte pour enregistrer les résultats
    FILE *fichier = fopen("resultats_divisions.txt", "w");

    // Vérifie si le fichier a été ouvert
    if (fichier == NULL) {
        printf("Erreur lors de l'ouverture du fichier.");
        return 1;
    }

    // Boucle sur chaque division demandée par l'utilisateur
    for (int i = 1; i <= nombreDivisions; i++) {
        unsigned int dividende, diviseur, reste;


        printf("Division %d - Entrez le dividende et le diviseur (séparés par un espace) : ", i);
        scanf("%u %u", &dividende, &diviseur);


        if (diviseur == 0) {
            printf("Erreur : Le diviseur ne peut pas être nul.\n");
            continue;  // Passe à la prochaine itération de la boucle
        }


        unsigned int quotient = division(dividende, diviseur, &reste);

        // Affiche les résultats à l'écran
        printf("Division %d: %u / %u = %u reste %u\n", i, dividende, diviseur, quotient, reste);

        // Enregistre les résultats dans le fichier texte
        fprintf(fichier, "Division %d: %u / %u = %u reste %u\n", i, dividende, diviseur, quotient, reste);
    }

    // Ferme le fichier
    fclose(fichier);




    return 0;
}
