/*
 ====================================================================================================
 Name of TP2 : Tp2sif1053
 The Authors : yanis Ait oumeziane / massylia Djerroud
 Description : Cours Architecture des Ordinateurs
 =====================================================================================================
 */


#include <stdio.h>

/**
 * Fonction de division binaire par restauration des restes partiels.
 *
 * @param dividend Le dividende (entre 0 et 65535).
 * @param divisor Le diviseur (entre 1 et 65535).
 * @param quotient Pointeur vers la variable pour stocker le quotient.
 * @param remainder Pointeur vers la variable pour stocker le reste.
 */
void division(int dividend, int divisor, int *quotient, int *remainder) {
    *quotient = 0;
    *remainder = 0;

    // Itération sur chaque bit du dividende
    for (int i = 15; i >= 0; i--) {
        *remainder <<= 1;  // Décalage à gauche du reste
        *remainder |= (dividend >> i) & 1;  // Ajout du prochain bit du dividende à droite du reste

        // Si le reste est plus grand ou égal au diviseur, soustraire et ajuster le quotient
        if (*remainder >= divisor) {
            *remainder -= divisor;
            *quotient |= (1 << i);
        }
    }
}

int main() {
    int numDivisions;

    // Demander le nombre de divisions
    printf("Entrez le nombre de divisions : ");
    scanf("%d", &numDivisions);

    // Ouvrir le fichier pour écrire les résultats
    FILE *file = fopen("resultats.txt", "w");
    if (file == NULL) {
        fprintf(stderr, "Erreur lors de l'ouverture du fichier.\n");
        return 1;
    }

    // Effectuer les divisions
    for (int i = 1; i <= numDivisions; i++) {
        int dividend, divisor, quotient, remainder;

        // Demander les valeurs du dividende et du diviseur
        printf("Division %d : Entrez le dividende et le diviseur (séparés par un espace) : ", i);
        scanf("%d %d", &dividend, &divisor);

        // Appeler la fonction de division
        division(dividend, divisor, &quotient, &remainder);

        // Afficher les résultats
        printf("Division %d : %d / %d = %d reste %d\n", i, dividend, divisor, quotient, remainder);

        // Écrire les résultats dans le fichier
        fprintf(file, "Division %d: %d / %d = %d reste %d\n", i, dividend, divisor, quotient, remainder);
    }

    // Fermer le fichier
    fclose(file);

    return 0;
}